<?php 

/**
* main component
*/
class component extends module {

	public $config;
	public $url;
	public $dbh;
	public $view;
	public $view_dir;
	public $component_dir;
	public $component_dir_core;
	public $data;
	public $page;
	public $model;
	
	function __construct($config, $url, $component, $dbh) {
		$this -> config = $config;
		$this -> url    = $url;		
		$this -> dbh    = $dbh;
  		$this -> view_dir         = ROOT_DIR .          '/modules/components/'.$component['name'].'/'.END_NAME.'/views';
  		$this -> view_dir_core    = ROOT_DIR . '/user_cms/modules/components/'.$component['name'].'/'.END_NAME.'/views';
  		$this -> page['title']            = '';
  		$this -> page['keywords']         = '';
  		$this -> page['description']      = '';
  		$this -> page['html']             = '';
		$this -> page['head']             = '';
		$this -> component_dir            = ROOT_DIR . '/modules/components/'.$component['name'].'/'.END_NAME;
		$this -> component_dir_core       = ROOT_DIR . '/user_cms/modules/components/'.$component['name'].'/'.END_NAME;
		$this -> component_name           = $component['name'];
		$this -> model                    = $this->load_model();

  	}

	function action_index() {
		$this->data['page_name'] = 'Название страницы не задано';
		$this->data['content'] = '<p style="margin: 20px 0;">Контент страницы не задан</p>';
		$this->data['bread_crumbs'] = '';
		$this->page['title'] = 'Тайтл страницы не задан';
		$this->page['keywords'] = 'Ключевики страницы не заданы';
		$this->page['description'] = 'Описание страницы не задано';
		$this->page['html'] = $this->load_view();
		$this->page['head'] = '';
		return $this->page;
	}

	function action_else() {
		return $this->action_404();
	}

	function action_404() {
		// отправляем заголовок 404
		$sapi_name = php_sapi_name();
		if ($sapi_name == 'cgi' || $sapi_name == 'cgi-fcgi') {
		    header('Status: 404 Not Found');
		} else {
		    header($_SERVER['SERVER_PROTOCOL'] . ' 404 Not Found');
		}
		$this->data['page_name'] = 'Страница не найдена';
		$this->data['content'] = '<p style="margin: 20px 0;">Ошибка 404 бывает в следующих случаях:	<ol><li>Страницу удалили</li><li>Страницу переместили</li><li>Страница еще не создана</li></ol>Воспользуйтесь меню сайта для поиска нужной информации!</p>';
		$this->data['bread_crumbs'] = '<a href="' . SITE_URL . '">Главная</a> -> Ошибка 404';
		$page['title'] = 'Страница не найдена. Ошибка 404';
		$page['keywords'] = '';
		$page['description'] = '';
		$page['html'] = $this->load_view();
		return $page;
	}
	
	function load_view($name='index') {
		$full_name = $this->view_dir . '/' . $name .'.tpl';
		$full_name_core = $this->view_dir_core . '/' . $name .'.tpl';
		extract($this->data);
		if (file_exists($full_name)) {
	        ob_start();
	        include $full_name;
	        return ob_get_clean();
	    } 
	    elseif (file_exists($full_name_core)) {
	        ob_start();
	        include $full_name_core;
	        return ob_get_clean();
	    } 
	    else {
	    	exit('Error3: file not found: ' . $full_name);
	    }
	}

	function load_model() {
		$model_full_name = 'model_component_' . $this->component_name;
		//core::print_r($model_full_name, 'Загружаем модель: ' . $this->component_name);
		return new $model_full_name($this->dbh);
	}

	protected function translit($str){
		$str = $this->mb_strtr($str, array(
			"а"=>"a","б"=>"b","в"=>"v","г"=>"g","д"=>"d","е"=>"e","ё"=>"e",
			"ж"=>"zh","з"=>"z","и"=>"i","й"=>"y","к"=>"k","л"=>"l","м"=>"m",
			"н"=>"n","о"=>"o","п"=>"p","р"=>"r","с"=>"s","т"=>"t","у"=>"u",
			"ф"=>"f","х"=>"h","ц"=>"ts","ч"=>"ch","ш"=>"sh","щ"=>"shch","ъ"=>"",
			"ы"=>"y","ь"=>"","э"=>"e","ю"=>"yu","я"=>"ya","ї"=>"i", "є"=>"ie",
			"А"=>"A","Б"=>"B","В"=>"V","Г"=>"G","Д"=>"D","Е"=>"E","Ё"=>"E",
			"Ж"=>"ZH","З"=>"Z","И"=>"I","Й"=>"Y","К"=>"K","Л"=>"L","М"=>"M",
			"Н"=>"N","О"=>"O","П"=>"P","Р"=>"R","С"=>"S","Т"=>"T","У"=>"U",
			"Ф"=>"F","Х"=>"H","Ц"=>"TS","Ч"=>"CH","Ш"=>"SH","Щ"=>"SHCH","Ъ"=>"",
			"Ы"=>"Y","Ь"=>"","Э"=>"E","Ю"=>"YU","Я"=>"YA","Ї"=>"I", "Є"=>"IE",
								)
					);			
		 return $str;
	}
	
	protected function redirect($url, $status = 302) {
		header('Status: ' . $status);
		header('Location: ' . str_replace('&amp;', '&', $url));
		exit();
	}
	
	protected function str2url($text) {
		// переводим в транслит
		$text = $this->translit($text);
		// в нижний регистр
		$text = strtolower($text);
		// пробел на тире
		$converter = array( '   ' => '-',   '  ' => '-',  ' ' => '-',);
		$text = strtr($text, $converter);
		// удаляем все лишнее
		$text = preg_replace('/[^a-z0-9_-]/u', '', $text);
		// удаляем начальные и конечные '-' и пробел
		$text = trim(trim($text), "-");
		
		return $text;
	}
	
	protected function mb_strtr($str, $from, $to = ''){
		if(is_array($from)) {
			$new_from = array_keys($from);
			return str_replace($new_from, $from, $str);
			
		} else {
			$from = preg_split('~~u', $from, null, PREG_SPLIT_NO_EMPTY);
			$to = preg_split('~~u', $to, null, PREG_SPLIT_NO_EMPTY);
			return str_replace($from, $to, $str);
		}
	}
}