<?php 

class controller_component_core_news extends component {
	
	public function action_index() {
		//echo '<pre>'; var_dump($this); echo '<pre>';
		//echo '<pre>'; print_r($this); echo '</pre>';
		//echo ROOT_DIR;
		$this->load_helper('image');
		$this->helper_image->check();
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notice'] = array();
		$this->data['page_name'] = '';

		if(isset($this->url['params']['success'])) {
			if($this->url['params']['success'] == 'added') {
				$this->data['success'][] = 'Новость добавлена.';
				if(isset($this->url['params']['news_id'])) {
					$this->data['success'][] = '<a href="' . SITE_URL . '/admin/news/edit/' . $this->url['params']['news_id'] . '">Редактировать</a>';
				}
			} elseif($this->url['params']['success'] == 'edited') {
				$this->data['success'][] = 'Новость изменена.';
				if(isset($this->url['params']['news_id'])) {
					$this->data['success'][] = '<a href="' . SITE_URL . '/admin/news/edit/' . $this->url['params']['news_id'] . '">Вернуться к редактированию</a>';
				}
			}
		}
		
		$params = array(
			'sort'=>'i.date_add DESC',
			'limit'=>'0,10',
			'join'=>'category_name'
		);
			
		$this->data['news'] = $this->model->get_news(0, $params);
		
		$page['title'] = 'Новости';
		$page['keywords'] = 'Новости';
		$page['description'] = 'Новости';
		$page['html'] = $this->load_view('index');
		
		return $page;
	}
	
	public function action_add() {
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();
		
		if(isset($_POST['name'])){
			$this->data['name'] = $_POST['name'];
			if(empty($this->data['name'])){
				$this->data['errors'][] = 'Не указан заголовок новости';
			}
		} else {
			$this->data['name'] = '';
		}
		
		if(isset($_POST['text'])){
			$this->data['text'] = $_POST['text'];
			if(empty($_POST['text'])) {
				$this->data['errors'][] = 'Не указан текст новости';
			}
		} else {
			$this->data['text'] = '';
		}	
		
		if(isset($_POST['preview'])){
			if(!empty($_POST['preview'])) {
				$this->data['preview'] = $_POST['preview'];
			} else {
				$this->data['preview'] = substr(strip_tags($_POST['text']), 0, 300); // TODO: добавить в настройки компонента выбор нужно ли обрезать текст новости для превью и выбор количества символов
			}
		} else {
			$this->data['preview'] = '';
		}
				
		if(isset($_POST['title']) && !empty($_POST['title'])){
			$this->data['title'] = $_POST['title'];
		} else {
			$this->data['title'] = $this->data['name'];
		}
						
		if(isset($_POST['keywords']) && !empty($_POST['keywords'])){
			$this->data['keywords'] = $_POST['keywords'];
		} else {
			$this->data['keywords'] = $this->data['name'];
		}
								
		if(isset($_POST['description']) && !empty($_POST['description'])){
			$this->data['description'] = $_POST['description'];
		} else {
			$this->data['description'] = $this->data['name'];
		}
										
		if(isset($_POST['url']) && !empty($_POST['url'])){
			$this->data['url'] = $this->str2url($_POST['url']);
		} elseif(isset($_POST['url']) && empty($_POST['url'])) {
			$this->data['url'] = $this->str2url($this->data['name']);
		} else {
			$this->data['url'] = '';
		}
		
		if(isset($_POST['category_id'])) {
			$this->data['category_id'] = $_POST['category_id'];
		} elseif(isset($this->url['params']['category_id'])) {
			$this->data['category_id'] = $this->url['params']['category_id'];
		} else {
			$this->data['category_id'] = 1;
		}
		
		if(isset($_POST['date_add']) && !$this->data['errors']) {
			if(!$this->data['date_add'] = strtotime($_POST['date_add'])) {
				$this->data['date_add'] = time();
			}
		} else {
			$this->data['date_add'] = date('d.m.Y H:i');
		}
		
		$this->data['date_edit'] = '';
		
		if(isset($_POST['submit_news']) && !$this->data['errors']){

			$news_id = $this->model->add_news_item($this->data);

			$redirect = SITE_URL . '/admin/news/success=added/news_id=' . $news_id;
			$this->redirect($redirect);
			
		}
		
		$this->data['text_submit'] = 'Добавить';
		$this->data['page_name'] = 'Добавление новости';
		$page['title'] = 'Добавление новости';
		$page['keywords'] = 'Добавление новости';
		$page['description'] = 'Добавление новости';
		$page['html'] = $this->load_view('form');
		return $page;
	}
	
	public function action_edit() {
		$this->data = $this->model->get_news_item($this->url['actions'][1]);
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notices'] = array();
		
		if(isset($this->url['params']['success']) && $this->url['params']['success'] == 'edited') {
			$this->data['success'][] = 'Новость изменена.';
		}
		
		if(isset($_POST['name'])){
			$this->data['name'] = $_POST['name'];
			if(empty($this->data['name'])){
				$this->data['errors'][] = 'Не указан заголовок новости';
			}
		}
		
		if(isset($_POST['text'])){
			$this->data['text'] = $_POST['text'];
			if(empty($_POST['text'])) {
				$this->data['errors'][] = 'Не указан текст новости';
			}
		}
		
		if(isset($_POST['preview'])){
			if(!empty($_POST['preview'])) {
				$this->data['preview'] = $_POST['preview'];
			} else {
				$this->data['preview'] = substr(strip_tags($_POST['text']), 0, 300);
			}
		}
				
		if(isset($_POST['title']) && !empty($_POST['title'])){
			$this->data['title'] = $_POST['title'];
		}
						
		if(isset($_POST['keywords']) && !empty($_POST['keywords'])){
			$this->data['keywords'] = $_POST['keywords'];
		}
								
		if(isset($_POST['description']) && !empty($_POST['description'])){
			$this->data['description'] = $_POST['description'];
		}
										
		if(isset($_POST['url']) && !empty($_POST['url'])){
			$this->data['url'] = $this->str2url($_POST['url']);
		} elseif(isset($_POST['url']) && empty($_POST['url'])) {
			$this->data['url'] = $this->str2url($this->data['name']);
		}
		
		if(isset($_POST['category_id'])) {
			$this->data['category_id'] = $_POST['category_id'];
		} elseif(isset($this->url['params']['category_id'])) {
			$this->data['category_id'] = $this->url['params']['category_id'];
		}
		
		if(isset($_POST['date_add'])) {
			$date_add = strtotime($_POST['date_add']);
			if($this->data['errors']) {
				$this->data['date_add'] = $_POST['date_add'];
			} elseif($date_add) {
				$this->data['date_add'] = $date_add;
			}
		} else {
			$this->data['date_add'] = date('d.m.Y H:i', (int)$this->data['date_add']);
		}
		
		if(isset($_POST['date_edit'])) {
			$date_edit = strtotime($_POST['date_edit']);
			if($this->data['errors']) {
				$this->data['date_edit'] = $_POST['date_edit'];			
			} elseif($date_edit) {
				$this->data['date_edit'] = $date_edit;
			}
		} elseif(!$this->data['date_edit']) {
			$this->data['date_edit'] = date('d.m.Y H:i');
		} else {
			$this->data['date_edit'] = date('d.m.Y H:i', (int)$this->data['date_edit']);
		}

		if(isset($_POST['submit_news']) && !$this->data['errors']) {
			$this->model->edit_news_item($this->data);

			$redirect = SITE_URL . '/admin/news/success=edited/news_id=' . $this->data['id'];
			$this->redirect($redirect);
		}

		
		$this->data['text_submit'] = 'Сохранить изменения';
		$this->data['page_name'] = 'Редактирование новости';
		$page['title'] = 'Редактирование новости';
		$page['keywords'] = 'Редактирование новости';
		$page['description'] = 'Редактирование новости';
		$page['html'] = $this->load_view('form');
		return $page;
	}
	
	public function action_settings() {
		$this->data['errors'] = array();
		$this->data['success'] = array();
		$this->data['notice'] = array();
		$this->data['page_name'] = '';
	}

}