<?php

define('USER_CMS_VERSION', 2.0);


/**
* main core class
* основной класс ядра 
* 2013.03.18
*/
class user_cms_core {
	
	public $html; // общий html код сайта
	public $config; // общие настройки
	public $url; // массив с частями урла
	public $component; // массив с настройками компонента
	public $theme; // массив с настройками темы
	public $page; // массив с настройками темы (заголовок, тайтл, мета теги и пр)
	public $head; // html код для тега head
	public $dbh; // db handle
	
	function __construct() {
       	
		session_start();

       	$this -> html = '';
		$this -> config = parse_ini_file(ROOT_DIR . '/config.ini');
		//core::print_r($this -> config,'config');
		define('SITE_URL', $this -> config['site_url']);
		define('SITE_NAME', $this -> config['site_name']);
		$this -> error_reporting();
		$this -> url = $this -> parse_url();

		// задаем по умолчанию 
		$this -> component['name']     = 'pages'; 
		$this -> component['action']   = 'index'; 
		$this -> component['view']     = 'index';
		$this -> component['html']     = '';
		$this -> component['dir']      = ROOT_DIR .          '/modules/components/' . END_NAME . '/pages';
		$this -> component['dir_core'] = ROOT_DIR . '/user_cms/modules/components/' . END_NAME . '/pages';

		$this -> theme['name']         = $this -> config['site_theme'];
		$this -> theme['file']         = 'index';
		$this -> theme['url']          = SITE_URL .          '/themes/' . $this -> theme['name']  ;
		$this -> theme['url_core']     = SITE_URL . '/user_cms/themes/' . $this -> theme['name']  ;
		$this -> theme['dir']          = ROOT_DIR .          '/themes/' . $this -> theme['name']  ;
		$this -> theme['dir_core']     = ROOT_DIR . '/user_cms/themes/' . $this -> theme['name']  ;


		$this -> page['title']         = '';
		$this -> page['keywords']      = '';
		$this -> page['description']   = '';
		$this -> page['html']          = '';


		$this -> head    		       = '';
		
		$this -> dbh = $this -> db_connect();
    }

	function load_addons($position) {
        // загружаем аддоны в позиции
        $end_name = (END_NAME == 'back_end') ? "AND back_end = '1'" : "AND back_end='0'";
        $sql = "SELECT * FROM activated_modules WHERE type='addon' AND position = '".$position."' ".$end_name." ORDER BY sort ASC";
   		$list_addons = $this->dbh->query($sql);
   		$html = '';
   		//core::print_r($list_addons);
   		foreach($list_addons as $addon) {
   			//core::print_r($addon);
   			$a = $this->load_addon($addon['module_dir']);
   			$this -> head .= $a['head'];
   			$html .= $a['html'];

   		}
   		return $html;
   	}
	
   	function load_component() {
		
   		if(empty($this->url['component'])) {
   			$this -> component['name']   = 'pages';
   			$this -> component['action'] = 'index';
    	} 
    	else {
    		if(END_NAME == 'front_end') {
				
	    		$sql = "SELECT * FROM `main` WHERE `url` = '" . $this->url['component'] . "'";
		    	$count = $this->dbh->query_count($sql);
				
		    	if($count == 0) {
		    		$this -> component['name']   = 'pages';
		    		$this -> component['action'] = '404';
		    	} 
		    	else {
		    		$row = $this->dbh->row($sql);
					
		    		if(!$row || $row['component'] == 'pages') {
		    			$this -> component['name']   = 'pages';
		    			$this -> component['action'] = 'else';
		    		} 
		    		else {
		    			$this -> component['name']   = $row['component'];
						if(method_exists('controller_component_' . $this -> component['name'], 'action_' . $this->url['actions'][0])) {
							$this -> component['action'] = $this->url['actions'][0];
						} 
						else {
							$this -> component['action'] = 'else';
						}
		    		}
		    	}
    		}
    		else {
				if(!isset($_SESSION['auth']) || $_SESSION['auth']===0 || (isset($_SESSION['access']) && $_SESSION['access'] < 1)){
					if($this->url['component'] != 'users' ||  ($this->url['component']=='users' && $this->url['actions'][0] != 'login')) {
						header('HTTP/1.1 301 Moved Permanently');
						header('Location: ' . $this->config['site_url'] . '/admin/users/login'); 
						exit();
					}
				}
    			// загружаем компоненты из админки (активация им не требуется)
    			$this -> component['name']   = $this->url['component'];
    			$this -> component['action'] = $this->url['actions'][0];
    		}
    	}
    	

   		$component_full_name = 'controller_component_' . $this -> component['name'];
   		//core::print_r ($component_full_name,'component_full_name');
		$c = new $component_full_name($this -> config, $this -> url,$this -> component, $this -> dbh);
		$component_action_name = 'action_' . $this -> component['action'];
		//core::print_r ($component_action_name,'component_action_name');
		$page = $c -> $component_action_name();
		
		$this->page['title']       = isset($page['title']) ? $page['title'] : $this->page['title'];
		$this->page['keywords']    = isset($page['keywords']) ? $page['keywords'] : $this->page['keywords'];
		$this->page['description'] = isset($page['description']) ? $page['description'] : $this->page['description'];
		$this->page['html']        = isset($page['html']) ? $page['html'] : $this->page['html'];
		
		foreach($this->theme as $key => $value) {
			$this->theme[$key] = (isset($page['theme'][$key])) ? $page['theme'][$key] : $this->theme[$key];
		}

   	}
	
	function load_theme() {
		if(END_NAME == 'back_end') {
			$this->theme['name'] = 'default_admin';
		}
		$theme['url']            = SITE_URL .          '/themes/' . $this->theme['name'] ;	
		$theme['url_core']       = SITE_URL . '/user_cms/themes/' . $this->theme['name'] ;	
		$theme['full_name']      = ROOT_DIR .          '/themes/' . $this->theme['name'] . '/' . $this->theme['file'] . '.tpl';	
		$theme['full_name_core'] = ROOT_DIR . '/user_cms/themes/' . $this->theme['name'] . '/' . $this->theme['file'] . '.tpl';	
		$theme['config']         = ROOT_DIR .          '/themes/' . $this->theme['name'] . '/config.ini';	
		$theme['config_core']    = ROOT_DIR . '/user_cms/themes/' . $this->theme['name'] . '/config.ini';	


		if(file_exists($theme['full_name'])) {
			ob_start();
	        include $theme['full_name'];
	        $this->html = ob_get_clean();

		}
		else {
			ob_start();
	        include $theme['full_name_core'];
	        $this->html = ob_get_clean();
			//echo $this->html;
		}
		// загружаем css и js файлы из конфига темы
		
		if(file_exists($theme['config'])) {
			$conf = parse_ini_file($theme['config']);
			
			foreach ($conf as $key => $value) {
				if($key=='js') {
					$arr = explode(',', $value);
					$js = '';
					foreach ($arr as  $val) {
						if( ! empty($val)) {
							$js .= '<script src="' . $theme['url'] . '/'.$val.'" type="text/javascript"></script>' . "\n\t";
						}
						
					}
					$this->head = $js . $this->head;
				}
				if($key=='css') {
					$arr = explode(',', $value);
					
					$css = '';
					foreach ($arr as  $val) {
						$css .= '<link href="' . $theme['url'] . '/'.$val.'" rel="stylesheet"  type="text/css" >' . "\n\t";
					}
					$this->head = $css . $this->head; 
				}
				
			}
		}
		elseif (file_exists( $theme['config_core'])) {
			$conf = parse_ini_file($theme['config_core']);
			//core::print_r($conf,'conf'); 
			foreach ($conf as $key => $value) {
				if($key=='js') {
					$arr = explode(',', $value);
					
					$js = '';
					foreach ($arr as  $value) {
						//core::print_r($theme['url_core']);
						$js .= '<script src="' . $theme['url_core'] . '/' . trim($value) . '" type="text/javascript"></script>' . "\n\t";
					}
					$this->head = $js . $this->head;
				}
				if($key=='css') {
					$arr = explode(',', $value);
					
					$css = '';
					foreach ($arr as  $value) {
						$css .= '<link href="' . $theme['url_core'] . '/' . trim($value) . '" rel="stylesheet"  type="text/css" >' . "\n\t";
					}

					$this->head = $css . $this->head; 
				}
			}
		} 
	}

	function load_blocks() {
	    // загружаем блоки
		$list_positions = $this->parse_html_for_positions();
		//core::print_r($list_positions,'list_positions');
	    foreach ($list_positions as $position) {
		    $html = '';
		    $sql = "SELECT * FROM activated_modules WHERE type='block' AND position = '{$position}' ORDER BY sort ASC";
		    $list_blocks = $this->dbh->query($sql);
		    //core::print_r($list_blocks);
		    foreach($list_blocks as $block) {
			    //core::print_r($block);
			    $b = $this->load_block($block['module_dir'],$block['params']);
			    $this -> head .= $b['head'];
			    $html .= $b['html'];
		    }
		    $this->html = str_replace('[position='.$position.']', $html, $this->html);
	   }
	}
	
   	function load_plugins() {
       	// загружаем плагины
		$list_plugins_positions = $this->parse_html_for_plugins();

   		$i=0;
   		foreach ($list_plugins_positions[1] as $plugin_position) {
   			$html = '';
   			$sql = "SELECT * FROM activated_modules WHERE type='plugin' AND position = '{$plugin_position}' ORDER BY sort ASC";
   			$list_plugins = $this->dbh->query($sql);
   			//core::print_r($list_plugins);
   			foreach($list_plugins as $plugin) {
	   			//core::print_r($plugin);
	   			//core::print_r($list_plugins_positions[2][$i]);
	   			$p = $this->load_plugin($plugin['module_dir'], $plugin['params'], $list_plugins_positions[2][$i]);
	   			$this -> head .= $p['head'];
	   			$html .= $p['html'];
   			}
   			//core::print_r('{'.$plugin_position.'=' . $list_plugins_positions[2][$i] . '}', 'Вот на что заменяем');
   			$this->html = str_replace('{'.$plugin_position.'=' . $list_plugins_positions[2][$i] . '}', $html, $this->html);
   			$this->page['html'] = str_replace('{'.$plugin_position.'=' . $list_plugins_positions[2][$i] . '}', $html, $this->page['html']);
   			$i++;
   		}
   	}
	
	function load_pre_echo() {
		// 1. [head] -> html код
		// 2. [component] -> html код
		


		$head = '
		<title>' . $this -> page['title']  . '</title>
		<meta charset="utf-8">
		<meta name="keywords" content="' . $this -> page['keywords'] . '">
		<meta name="description" content="' . $this -> page['description'] . '">
		<link rel="icon" href="' . $this -> config['site_url'] . '/favicon.ico" type="image/x-icon">
		<link rel="shortcut icon" href="' . $this -> config['site_url'] . '/favicon.ico" type="image/x-icon">
		' . $this -> head ;
		$this->html = str_replace('[head]', $head, $this->html);
		$this->html = str_replace('[component]', $this -> page['html'], $this->html);

		//echo $this->html;
	}

     function __destruct() {
       	// закрываем соединение с базой
   		$this -> db_close();
    }

   	//////////////// вспомогательные функции

	function parse_url() {
		$url = array();
		$url['component'] = '';
		$url['actions'] = array();
		$url['params'] = array();

		//echo $config;
		$pre =  'http://' . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'] ;
		$pre = str_replace($this->config['site_url'],'',$pre);
		if(strpos($pre, 'http://') === 0) {
			exit('Error #1: Site URL in config.ini is wrong.');
		}
		$pre = explode('/', $pre);
		
		// разная разбивка URL в зависимости от того находимся ли мы в админ панели или нет
		if($pre[1] == 'admin') {
			define('END_NAME', 'back_end');
			if( ! isset($pre[2])) {
				$url['component']='pages';
			} else {
				$url['component'] = $pre[2];
			}
			$i=3;
		}
		else {
			define('END_NAME', 'front_end');
			$url['component'] = $pre[1];
			$i=2;
		}

		while($i <= count($pre)) {
			if(!empty($pre[$i])) {
				if(strpos($pre[$i], '=') !== false) {
					$pre2 = explode('=', $pre[$i]);
					$url['params'][$pre2[0]] = $pre2[1];
				} 
				else {
					$url['actions'][] = $pre[$i];
				}
			}
			$i++; 
		}
		if(count($url['actions'])==0) {
			$url['actions'][0]='index';
		}
		// склеиваем index.php, index.html, index.htm, index c /
		if($url['component'] == 'index.php' or $url['component'] == 'index.html' or $url['component'] == 'index.htm' or $url['component'] == 'index' ) {
			header('HTTP/1.1 301 Moved Permanently');
			header('Location: ' . $this->config['site_url']); 
			exit();
		}
		//core::print_r($pre,'pre');
		//core::print_r($url,'url');
		return $url;
	}

	function db_connect() {
		require_once(ROOT_DIR . '/user_cms/helpers/sqlite_pdo.php');
		$dbh = new DB("sqlite:". ROOT_DIR ."/db.sqlite");
		if($this->config['db_error_reporting']){
			$dbh->error = true;
		}
  		//$dbh -> connect();
  		//$items = $dbh -> get_array("SELECT * FROM `main`");
    	//core::print_r($items);
    	return $dbh;
	}
	function db_close() {
		$this -> dbh = NULL;
	}

	function error_reporting() {

		error_reporting($this -> config['error_reporting']);
	}
	
	function load_addon($addon_dir) {
		$full_name = 'controller_addon_' . $addon_dir;
		$a = new $full_name($this->config, $this->url, $addon_dir, $this->dbh);
		return $a->action_index();
		
	}
	
	function load_block($block_dir, $params='', $action='index') {
        $full_name = 'controller_block_' . $block_dir;
        $b = new $full_name($this->config, $this->url, $block_dir, $this->dbh);
        $full_action_name = 'action_' . $action;
        //core::print_r($full_name,'$full_name');
        //core::print_r($full_action_name,'$full_action_name');
        //core::print_r($params,'$params');
        return $b->$full_action_name($params);
       
    }
	
	function load_plugin($plugin_dir, $params='', $run_params='') {
		$full_name = 'controller_plugin_' . $plugin_dir;
		$p = new $full_name($this->config, $this->url, $plugin_dir, $this->dbh);
		$p->run_params = $run_params; // добавляем объекту свойство, содержащее строку с параметрами, передаваемыми в шаблоне
		return $p->action_index($params);
	}

	function parse_html_for_positions() {
		preg_match_all("/\[position\=(.*)\]/U", $this->html ,  $out); 
		
		return $out[1];
		
	}

	function parse_html_for_plugins() {
		$html = $this->html . $this->page['html'];
		preg_match_all("/\{(.*)\=(.*)\}/U", $html ,  $out); 

		return $out;
	}
	
	function parse_component_for_plugins() {
		preg_match_all("/\{(.*)\=(.*)\}/U", $this->page['html'] ,  $out); 

		return $out;
		
	}

	function print_r($var, $var_name = '') {
		echo '<pre style="outline: 1px dotted grey;padding:5px;">';
		if( ! empty($var_name)) {
			echo '<h3>' . $var_name . '</h3>';
		}
		if(is_string($var)){
			$var = htmlspecialchars($var);
		}
		print_r($var);
		echo '</pre>';
	}

	function var_dump($var, $var_name = '') {
		echo '<pre style="outline: 1px dotted grey;padding:5px;">';
		if( ! empty($var_name)) {
			echo '<h3>' . $var_name . '</h3>';
		}
		var_dump($var);
		echo '</pre>';
	}


}


function __autoload($class_name) {
	$core_dir        = '/user_cms';
	$module_type_dir = '/components';
	$module_name_dir = '/pages';
	$end_name        = '';
	
	if($class_name == 'component') {
		require_once(ROOT_DIR . '/user_cms/modules/component.php');
	}
    elseif($class_name == 'model') {
		require_once(ROOT_DIR . '/user_cms/modules/model.php');
	}
    elseif($class_name == 'addon') {
		require_once(ROOT_DIR . '/user_cms/modules/addon.php');
	}
    elseif($class_name == 'block') {
		require_once(ROOT_DIR . '/user_cms/modules/block.php');
	}
    elseif($class_name == 'plugin') {
		require_once(ROOT_DIR . '/user_cms/modules/plugin.php');
	}
    elseif($class_name == 'module') {
		require_once(ROOT_DIR . '/user_cms/modules/module.php');
	}
    elseif(strpos($class_name, 'controller_') === 0 OR strpos($class_name, 'model_') === 0) {
    	$file_name =  str_replace( array('controller_','model_'), '', $class_name);
        
  		if(strpos($file_name, 'component_') === 0) {
  			$module_type_dir = '/components';
  			$end_name        = '/' . END_NAME;
  		}
  		elseif(strpos($file_name, 'addon_') === 0) {
  			$module_type_dir = '/addons';
  		}
  		elseif(strpos($file_name, 'plugin_') === 0) {
  			$module_type_dir = '/plugins';
  		}
  		elseif(strpos($file_name, 'block_') === 0) {
  			$module_type_dir = '/blocks';
  		}
  		$module_name_dir =  str_replace(array('component_', 'addon_', 'plugin_', 'block_'), '', $file_name);
  		$core_dir = (strpos($module_name_dir, 'core_') === 0) ? '/user_cms' : '';
  		$module_name_dir =  str_replace('core_', '', $module_name_dir);

  		$f = ROOT_DIR . $core_dir .  '/modules' . $module_type_dir . '/' . $module_name_dir . $end_name . '/' . $class_name . '.php';
  		//core::print_r($f,'Файл: ');
    	if(  file_exists($f)) {
           	require_once($f);
        }
        else {
            exit('Error #2: wrong class name: '.$class_name);
        } 
    }
}   


